	 
#include <gtk/gtk.h>
#include <glib.h>
#include "../include/gnome-dialog.h"
#include "intl.h" // Added internationalize support

void MessageBox(const gchar *str)
{
	GtkWidget *dialog, *label, *ok_button;
	GtkWidget *buttonbox;

	/* Create the widgets */
	dialog = gnome_dialog_new("", NULL);
	label = gtk_label_new (str);
	gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
	ok_button = gtk_button_new_with_label(_("OK"));
	buttonbox = gtk_hbutton_box_new();

	/* Ensure that the dialog box is destroyed when the user clicks ok. */
	gtk_signal_connect_object(GTK_OBJECT (ok_button), "clicked", gtk_widget_destroy, GTK_OBJECT(dialog));
	gtk_container_add (GTK_CONTAINER (GNOME_DIALOG(dialog)->action_area), buttonbox);
	gtk_container_add (GTK_CONTAINER (buttonbox), ok_button);

	/* Add the label, and show everything we've added to the dialog. */
	gtk_container_add (GTK_CONTAINER (GNOME_DIALOG(dialog)->vbox), label);
	
	gtk_widget_show_all (dialog);

	gnome_dialog_close_hides(GNOME_DIALOG(dialog), FALSE);
	gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
	
	gnome_dialog_run_and_close(GNOME_DIALOG(dialog));
}

