/*
 * Hello.c
 *
 * Example showing different widgets in use.
 *
*/
/* 3-Apr-2001 Change by Jason that all the "float" variable change */
/* to "double" to increase the precision.			   */

#include "gtk/gtk.h"
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>


/*
 * CloseAppWindow
 *
 * The window is closing down, end the gtk loop
*/
gint CloseAppWindow (GtkWidget *widget, gpointer data)
{
    gtk_main_quit ();

    return (FALSE);
}


/*
 * button_clicked
 *
 * widget - button pressed.
 * data - button label.
*/
void button_clicked (GtkWidget *widget, gpointer data)
{
   printf("button_clicked\n");
}


/*
 * key_press
 *
 * Handle the button "key_press" event.
*/
void key_press (GtkWidget *widget,
                GdkEventKey *event,
                gpointer data)
{
   printf("key_press\n");
}


/*
 * main
 *
 * Program begins here
*/
int main (int argc, char *argv[])
{
    GtkWidget *toplevel, *layout, *button;
    gtk_set_locale();
    gtk_init (&argc, &argv);

    /* --- Create the calculator window --- */
    toplevel = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_border_width(GTK_CONTAINER(toplevel), 10);

    /* --- Give the window a title. --- */
    gtk_window_set_title (GTK_WINDOW (toplevel), "hello");

    /* --- Set the window size. --- */
    gtk_widget_set_usize (toplevel, 120, 120);

    /* --- We care if a key is pressed --- */
    gtk_signal_connect (GTK_OBJECT (toplevel), "key_press_event",
                        GTK_SIGNAL_FUNC (key_press), NULL);

    /* --- You should always remember to connect the delete event
     *     to the main window. --- */
    gtk_signal_connect (GTK_OBJECT (toplevel), "delete_event",
                        GTK_SIGNAL_FUNC (CloseAppWindow), NULL);

    /* Create a fixed box an the main container */
    layout = gtk_fixed_new();
    gtk_widget_show(layout);
    gtk_container_add(GTK_CONTAINER(toplevel), layout);

    /* --- Create a button --- */
    button = gtk_button_new_with_label ("world");
    gtk_widget_set_usize (button, 100, 100);

    /* --- Make them visible --- */
    gtk_fixed_put(GTK_FIXED(layout), button, 0, 0);
    gtk_widget_show (button);

    /* --- We care if the button is clicked --- */
    gtk_signal_connect (GTK_OBJECT (button), "clicked",
                        GTK_SIGNAL_FUNC (button_clicked), NULL);

    gtk_widget_show (toplevel);

    gtk_main ();
    return (0);
}



