#ifndef _scheduleH_h
#define _scheduleH_h

#include <stdio.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gtk/gtkclist.h>
#include "desktop.h"

#define TOPLEVEL_NM     "Scheduler"

#if (PCFB || PDA)
#define TOPLEVEL_X      0
#define TOPLEVEL_Y      0
#else
#define TOPLEVEL_X      620//450
#define TOPLEVEL_Y      105//250
#endif

#define TOPLEVEL_WD     WINDOW_WIDTH
#define TOPLEVEL_HT     WINDOW_HEIGHT

#define ALL_SPACE       0
#define FIRST_SPACE     0
#define SECOND_SPACE    0
#define THIRD_SPACE     0

#define TOPBOX_WD       TOPLEVEL_WD
#define TOPBOX_HT       24

#define SWLIST_WD       TOPLEVEL_WD - 22
#define SWLIST_HT       (TOPLEVEL_HT - FIRST_SPACE - TOPBOX_HT \
			 - SECOND_SPACE - BUTTON_HT - THIRD_SPACE)

#define TIME_INX        0
#define TIME_WD         30
#define EVENT_INX       1
#define EVENT_WD        150
#define LIST_ROW_HT     17

#define BUTTON_WD       45
#define BUTTON_HT       25

#define HOUR_BEGIN      0
#define WORK_BEGIN      8
#define LUNCH_BEGIN     13
#define LUNCH_END       14
#define WORK_END        18
#define HOUR_END        23
#define	NUM_HOURS	(HOUR_END - HOUR_BEGIN + 1)

#define TIME_MINUTE	'M'
#define TIME_HOUR	'H'
#define TIME_DAY	'D'

#define MIN_UNIT_VAL	0
#define MAX_UNIT_VAL	99

#define DEF_TIME_UNIT	TIME_MINUTE
#define DEF_SETOFF_TM	15



typedef struct _task_info
{
   gint  year;		/* scheduled year */
   gint  month;		/* scheduled month */
   gint  day;		/* scheduled day */
   gint  hour;		/* scheduled hour */
   gint  minute;	/* scheduled minute */
   gchar *summary;	/* schedule summary */
   gchar *details;	/* schedule details */
   gint  row;		/* selected row in list */
   time_t tref;		/* time reference */
   gint   tsoff;	/* alarm setoff time duration */
   gchar  tunit;	/* alarm setoff time units */
   struct _task_info *next;
} task_info;


#endif

