#!/bin/sh

GTK_DIR=NanoGTK-1.0
GTK_VN=1.2.7
GLIB_VN=1.2.7
MWIN_VN=089p8


if [ x$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      export NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/$USER/$GTK_DIR ]; then
      export NANOGTK_HOME=/home/$USER/$GTK_DIR
   else
      echo
      echo "NANOGTK_HOME not defined"
      exit 1
   fi
fi


show_usage ()
{
   echo
   echo "usage: $0 <pub | x86>"
   echo
   exit 0
}


build_package ()
{
   cd $1

   ./rebuild.sh $MARCH

   if [ $? != 0 ]; then
      exit 1
   fi

   cd ..
}


make_package ()
{
   cd $1

   make clean
   make $MARCH

   if [ $? != 0 ]; then
      exit 1
   fi

   cd ..
}


#
# compile libraries in application directory
#
compile_applib ()
{
   all="EmAppLib"

   for d in $all
   do
      make_package $d
   done
}


#
# compile others in application directory
#
compile_app ()
{
   all=`ls`

   for d in $all
   do
      if [ -d $d -a -f $d/Makefile ]; then
         make_package $d
      fi
   done
}


#
# Script execution starts from here
#
GTK_VN=1.2.7
GLIB_VN=1.2.7
MWIN_VN=089p5


if [ x$1 = x ]; then
   show_usage
fi


case $1 in
   pub|x86)
      MARCH=$1

#      echo
#      echo -n "Are you sure to rebuild all applications (y/n)? "
#      read answer

#      if [ "$answer" != y ]; then
#         echo "aborted"
#         exit 0
#      fi
      ;;
   *)
      show_usage
      ;;
esac


compile_applib
compile_app


exit 0

