#!/bin/sh


check_dir ()
{
   if [ ! -d $1 ]; then
      echo
      echo "Could not find directory $1"
      echo
      exit 0
   fi
   echo "Found $1"
}


link_file ()
{
   if [ -h $2 ]; then
      rm -f $2
   fi

   if [ -f $1 -o -d $1 ]; then
      echo "ln -s $1 $2"
      ln -s $1 $2
   fi
}

exec_cmd ()
{
   echo "$*"
   $*
}


#
# save current working directory
#
THISDIR=`pwd`


#
# locate NanoGTK installation directory
#
if [ "$NANOGTK_HOME" = "" ]; then
   INSTDIR=`dirname \`pwd\``
else
   INSTDIR=$NANOGTK_HOME
fi

check_dir $INSTDIR


#
# set testing directory
#
TESTDIR=$INSTDIR/Testbench

check_dir $TESTDIR


#
# check installed library and application directories
#
check_dir $INSTDIR/glib-1.2.7
check_dir $INSTDIR/gtk+-1.2.7
check_dir $INSTDIR/microwin
check_dir $INSTDIR/zlib
check_dir $INSTDIR/Application


#
# remove files not distributed with this Testing directory
#
exec_cmd cd $TESTDIR

exec_cmd rm -f nanowm nano-X
exec_cmd rm -f programs/*


