#!/bin/sh

#
# Nano-X PC emulation environment setup script
#

check_dir ()
{
   if [ ! -d $1 ]; then
      echo
      echo "Could not find directory $1"
      echo
      exit 0
   fi
   echo "Found $1"
}


#
# locate NanoGTK installation directory
#
if [ x$NANOGTK_HOME = x ]; then
   INSTDIR=`dirname \`pwd\``
   NANOGTK_HOME=$INSTDIR
else
   INSTDIR=$NANOGTK_HOME
fi


#
# set testing directory
#
MARCH=x86
TESTDIR=$INSTDIR/Testbench

check_dir $TESTDIR


#
# set up environment variables
#
LIBGLIB=$INSTDIR/glib-1.2.7/lib-$MARCH
LIBGTK=$INSTDIR/gtk+-1.2.7/lib-$MARCH
LIBMICROWIN=$INSTDIR/microwin/lib-$MARCH
LIBAPPLICATION=$INSTDIR/Application/lib-$MARCH

export LD_LIBRARY_PATH=$LIBGLIB:$LIBGTK:$LIBMICROWIN:$LIBAPPLICATION
export FONT_PATH=$TESTDIR/fonts
export PATH=$INSTDIR/gtk+-1.2.7/bin-$MARCH:$INSTDIR/glib-1.2.7/bin-$MARCH
export PATH=$PATH:/usr/local/bin:/bin:/usr/bin:/usr/X11R6/bin:.


unset LIBAPPLICATION
unset LIBMICROWIN
unset LIBGTK
unset LIBGLIB
unset TESTDIR
unset INSTDIR

