#!/bin/sh

GTK_DIR=NanoGTK-1.0
GTK_VN=1.2.7
GLIB_VN=1.2.7
MWIN_VN=089p8


if [ x$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      export NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/$USER/$GTK_DIR ]; then
      export NANOGTK_HOME=/home/$USER/$GTK_DIR
   else
      echo
      echo "NANOGTK_HOME not defined"
      exit 1
   fi
fi

compile ()
{
   ./makeit.sh $1 $debug

   rcode=$?

   if [ $rcode != 0 ]; then
      exit $rcode
   fi
}


moveit ()
{
   if [ ! -d include ]; then
      mkdir include
   else
      rm -f include/*
   fi

   cp -p glib.h glibconfig.h include
   cp -p gmodule/gmodule.h include
}


fixit ()
{
   BINDIR=bin-$1
   LIBDIR=lib-$1

   echo $NANOGTK_HOME | sed -e "s/\//\\\\\//g" > tt1
   PREFIX=`cat tt1`
   cat $BINDIR/glib-config | sed -e "s/$PREFIX/\$NANOGTK_HOME/g" > tt1
   cat tt1 | sed -e "s/lib\/glib\/include/include/g" > tt2
   cat tt2 | sed -e "s/glib-$GLIB_VN\/lib/glib-$GLIB_VN\/lib-$1/g" > tt1
   cat tt1 | sed -e "s/{exec_prefix}\/lib/{exec_prefix}\/lib-$1/g" > tt2

cat > tt1 << EOF
#!/bin/sh

if [ x\$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/\$USER/$GTK_DIR ]; then
      NANOGTK_HOME=/home/\$USER/$GTK_DIR
   else
      echo
      echo "Please define NANOGTK_HOME first"
      echo
      exit 1
   fi
fi
EOF

   cat tt2 | sed -e "s/#!\/bin\/sh//" >> tt1

   mv tt1 $BINDIR/glib-config
   rm -f tt2

   chmod a+x $BINDIR/glib-config
   mv bin/glib-config bin/glib-config.bak
}

debug="$2"

case $1 in
   pub|x86)
      compile $1
      moveit
      fixit x86
      ;;
   fixx86)
      moveit x86
      fixit x86
      ;;
   *)
      makeit.sh
      ;;
esac

