#include "nintl.h"
#include "device.h"


/*
 * [Simplified Chinese] - GB2312
 *      First  byte range: 0xa1-0xfe
 *      Second byte range: 0xa1-0xfe
 */
MWBOOL
is_simp_chinese_char (unsigned char c1, unsigned char c2)
{
        return ((c1 >= 0xa1 && c1 <= 0xfe)
                && (c2 >= 0xa1 && c2 <= 0xfe));
}


/*
 * [Simplified Chinese] - GBK
 *      First  byte range: 0x81-0xfe
 *      Second byte range: 0x40-0x7e, 80-fe
 */
MWBOOL
is_gbk_char (unsigned char c1, unsigned char c2)
{
        return (c1 >= 0x81 && c1 <= 0xfe
                && (  (c2 >= 0x40 && c2 <= 0x7e)
                   || (c2 >= 0x80 && c2 <= 0xfe))
               );
}

/*
 * [Traditional Chinese] - BIG5
 *      First  byte range: 0xa1-0xfe
 *      Second byte range: 0x40-0x7e, 0xa1-0xfe
 */
MWBOOL
is_trad_chinese_char (unsigned char c1, unsigned char c2)
{
        if ((c1 >= 0xa1 && c1 <= 0xfe) &&
           ((c2 >= 0x40 && c2 <= 0x7e) ||
           ((c2 >= 0xa1 && c2 <= 0xfe))))
                return TRUE;
        else
                return FALSE;
}

/*
 * [Japanese] - JIS
 *      First  byte range: 0xa1-0xfe
 *      Second byte range: 0xa1-0xfe
 */
MWBOOL
is_japanese_char (unsigned char c1, unsigned char c2)
{
        return ((c1 >= 0xa1 && c1 <= 0xfe)
                && (c2 >= 0xa1 && c2 <= 0xfe));
}

/*
 * [Korean] - KSC
 *      First  byte range: 0xa1-0xfe
 *      Second byte range: 0xa1-0xfe
 */
MWBOOL
is_korean_char (unsigned char c1, unsigned char c2)
{
        return ((c1 >= 0xa1 && c1 <= 0xfe)
                && (c2 >= 0xa1 && c2 <= 0xfe));
}


int GrInternAtom(const char* atom_name, int only_if_exists)
{
   return 0;
}

