#!/bin/sh

GTK_DIR=NanoGTK-1.0
GTK_VN=1.2.7
GLIB_VN=1.2.7
MWIN_VN=089p8


if [ x$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      export NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/$USER/$GTK_DIR ]; then
      export NANOGTK_HOME=/home/$USER/$GTK_DIR
   else
      echo
      echo "NANOGTK_HOME not defined"
      exit 1
   fi
fi


compile ()
{
   ./makeit.sh $1 $debug

   rcode=$?

   if [ $rcode != 0 ]; then
      exit $rcode
   fi
}


moveit ()
{
   BINDIR=bin-$1
   LIBDIR=lib-$1

   rm -fr $BINDIR
   mv bin $BINDIR

   rm -fr $LIBDIR
   mkdir $LIBDIR

   mv gdk/.libs-$1/lib* $LIBDIR
   mv gtk/.libs-$1/lib* $LIBDIR
}


fixit ()
{
   BINDIR=bin-$1
   LIBDIR=lib-$1

   echo $NANOGTK_HOME | sed -e "s/\//\\\\\//g" > tt1
   PREFIX=`cat tt1`
   cat $BINDIR/gtk-config | sed -e "s/$PREFIX/\$NANOGTK_HOME/g" > tt1
   cat tt1 | sed -e "s/-I\$NANOGTK_HOME\/glib-$GLIB_VN\/lib\/glib\/include//g" > tt2
   cat tt2 | sed -e "s/glib-$GLIB_VN\/lib/glib-$GLIB_VN\/lib-$1/g" > tt1
   cat tt1 | sed -e "s/{exec_prefix}\/lib/{exec_prefix}\/lib-$1/g" > tt2
   cat tt2 | sed -e "s/microwin\/src\/include/microwin\/include/g" > tt1
   cat tt1 | sed -e "s/microwin\/src\/lib/microwin\/lib-$1/g" > tt2
   cat tt2 | sed -e "s/    -lm -lm/ -lm/g" > tt1

cat > tt2 << EOF
#!/bin/sh

if [ x\$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/\$USER/$GTK_DIR ]; then
      NANOGTK_HOME=/home/\$USER/$GTK_DIR
   else
      echo
      echo "Please define NANOGTK_HOME first"
      echo
      exit 1
   fi
fi
EOF

   cat tt1 | sed -e "s/#!\/bin\/sh//" >> tt2

   mv tt2 $BINDIR/gtk-config
   chmod a+x $BINDIR/gtk-config
   rm -f tt1

   rm $LIBDIR/libgdk.la
   cp -p gdk/libgdk.la $LIBDIR

   rm $LIBDIR/libgtk.la
   cp -p gtk/libgtk.la $LIBDIR
}

debug="$2"

case $1 in
   pub|x86)
      compile $1
      moveit x86
      fixit x86
      ;;
   fixx86)
      moveit x86
      fixit x86
      ;;
   *)
      makeit.sh
      ;;
esac

