#!/bin/sh

GTK_DIR=NanoGTK-1.0
GTK_VN=1.2.7
GLIB_VN=1.2.7
MWIN_VN=089p8


if [ x$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      export NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/$USER/$GTK_DIR ]; then
      export NANOGTK_HOME=/home/$USER/$GTK_DIR
   else
      echo
      echo "NANOGTK_HOME not defined"
      exit 1
   fi
fi


compile ()
{
   cd src
   ./makeit.sh $1

   rcode=$?
   cd ..

   if [ $rcode != 0 ]; then
      exit $rcode
   fi
}


moveit()
{
   BINDIR=bin-$1
   LIBDIR=lib-$1

   if [ ! -d include ]; then
      mkdir include
   else
      rm -f include/*
   fi

   cp -p src/include/*.h include
   cp -p src/include/*.def include

   rm -fr $BINDIR/nano*
   rm -fr $LIBDIR

   if [ -d src/$BINDIR ]; then
      install -d $BINDIR
      cp -af src/$BINDIR/* $BINDIR
   fi

   if [ -d src/$LIBDIR ]; then
      install -d $LIBDIR
      cp -af src/$LIBDIR/*.a src/$LIBDIR/*.so $LIBDIR
   fi
}


case "$1" in
   pub|x86|pcfb)
      compile $1
      moveit x86
      ;;
   fixit)
      moveit x86
      ;;
   *)
      src/makeit.sh
      ;;
esac

exit 0

