#ifndef srvevent_gtkC_c
#define srvevent_gtkC_c

#ifdef CLIPBOARD_SUPPORT
void
GsDeliverSelectionEvent(GR_WINDOW* owner, GR_EVENT_TYPE type,
        GR_WINDOW_ID requestor, GR_ATOM_ID atom, GR_ATOM_ID target,
        GR_ATOM_ID property, GR_TIME time)
{
        GR_EVENT_SELECTION *ep;            /* mouse button event */
        GR_EVENT_CLIENT *ecp;           /* current event client */
        GR_EVENT_MASK   eventmask;      /* event mask */
        GR_WINDOW       *reqwp;

        eventmask = GR_EVENTMASK(type);
        if (eventmask == 0)
                return;

        reqwp = GsFindWindow(requestor);

        for (ecp = owner->eventclients; ecp; ecp = ecp->next) {
                //if ((ecp->eventmask & eventmask) == 0)
                  //      continue;

                ep = (GR_EVENT_SELECTION*) GsAllocEvent(ecp->client);
                if (ep == NULL)
                        continue;

                ep->type = type;
                ep->owner = owner->id;
                ep->requestor = requestor;
                ep->selection = atom;
                ep->target = target;
                ep->property = property;
                ep->time        = time;

                GsEventReady((GR_EVENT *)ep,ecp->client);
                if(ecp->client->pid != reqwp->eventclients->client->pid)
                        GsSendContSig(owner);

                printf("Delivering %d to %d target is %d\n",type,owner->id, target);
        }
}

void
GsDeliverPropertyEvent(GR_WINDOW* wp, GR_ATOM_ID atom, GR_TIME time,
        GR_STATUS state)
{
        GR_EVENT_PROPERTY *ep;            /* property event */
        GR_EVENT_CLIENT *ecp;           /* current event client */

        for (ecp = wp->eventclients; ecp; ecp = ecp->next) {
                if ((ecp->eventmask & GR_EVENT_MASK_PROPERTY_NOTIFY) == 0)
                        continue;

                ep = (GR_EVENT_PROPERTY*) GsAllocEvent(ecp->client);
                if (ep == NULL)
                        continue;

                ep->type = GR_EVENT_TYPE_PROPERTY_NOTIFY;
                ep->wid  = wp->id;
                ep->atom = atom;
                ep->time = time;
                ep->state = state;

                GsEventReady((GR_EVENT *)ep,ecp->client);
                printf("Delivering %d to %d atom is %d\n",ep->type, wp->id,atom);
        }
}
#endif // CLIPBOARD_SUPPORT

void GsDeliverLangEvent(int encoding,GR_SIZE width)
{
        GR_CLIENT               *client;
        GR_EVENT_LANG   *gp;            /* general event */

        printf("Sendnig new lang\n");
        client = root_client;
        while(client) {
                gp = (GR_EVENT_LANG *) GsAllocEvent(client);
                if (gp == NULL)
                        continue;
                gp->type = GR_EVENT_TYPE_LANG;
                gp->encoding = encoding;
                gp->width = width;
                GsEventReady((GR_EVENT *)gp,client);
                client= client->next;
        }
}

//extern int connection_number;
static void
GsEventReady(GR_EVENT *ev, GR_CLIENT * cl)
{
#ifdef USE_SIGNAL
        kill(cl->pid,SIGUSR1);
#endif
#ifdef USE_SOCKET
        GrSendEvent(ev,cl->id);
#endif
        //write(connection_number,'a',1);
        //printf("Sending Event id=%d\n", cl->id);
}

void GsFreeMotionEvent(GR_CLIENT *client, GR_WINDOW_ID wid, GR_WINDOW_ID subwid){
        GR_EVENT_LIST   *elp;           /* current element list */
        GR_EVENT_LIST   *prevelp;       /* previous element list */

        prevelp = NULL;
        for (elp = client->eventhead; elp; prevelp = elp, elp = elp->next) {
                if (elp->event.type != GR_EVENT_TYPE_MOUSE_MOTION)
                        continue;
                if (elp->event.mouse.wid != wid)
                        continue;
                if (elp->event.mouse.subwid != subwid)
                        continue;

                /*
                 * Found one, remove it and put it back on the free list.
                 */
                if (prevelp)
                        prevelp->next = elp->next;
                else
                        client->eventhead = elp->next;
                if (client->eventtail == elp)
                        client->eventtail = prevelp;

                elp->next = eventfree;
                eventfree = elp;
                return;
        }
}


#endif // srvevent_gtkC_c

