#ifndef srvnet_gtkC_c
#define srvnet_gtkC_c

#ifdef USE_SOCKET
void
GrSendEvent(GR_EVENT *evt,int socket)
{
        if (socket>0)
        {
//		printf("GrSendEvent type=%d\n", evt->type);

                GsWriteType(socket, GrNumGetNextEvent);
                GsWrite(socket, evt, sizeof(GR_EVENT));
        }
}
#endif

void
GrSetBackgroundColorWrapper(void *r)
{
        nxSetBackgroundColorReq *req = r;

        GrSetBackgroundColor(req->windowid, req->color);
}

static void
GrSetGCSubWindowModeWrapper(void *r)
{
        nxSetGCSubWindowModeReq *req = r;

        GrSetGCSubWindowMode(req->gcid, req->subwindowmode);
}

static void
GrSetGCLineAttribWrapper(void *r)
{
        nxSetGCLineAttribReq *req = r;

        GrSetGCLineAttrib(req->gcid, req->mask, req->line_width, req->line_style);
}

static void
GrSetGCLineDashSizesWrapper(void *r)
{
        nxSetGCLineDashSizesReq *req = r;
        GR_COUNT count;
        count = GetReqVarLen(req)/sizeof(GR_DASH_SIZE);
        GrSetGCLineDashSizes(req->gcid, count, (GR_DASH_SIZE*)GetReqData(req));
}

/* By Yick_2002_03_07 */
static void
GrGrabPointerWrapper(void *r)
{
            // Now copy what we got from the client....
        nxGrabPointerReq *req = r;
        GrGrabPointer(req->wid, req->mask);
}
/* end of by Yick_2002_03_07*/

static void
GrScrollWindowWrapper(void * r)
{
        nxScrollWindowReq * req = r;

        GrScrollWindow(req->wid, req->gcid, req->offx, req->offy);
}

static void
GrGetNextExposeWinWrapper(void *r)
{
        nxGetNextExposeWinReq *req = r;
        GR_EVENT evt;
        GR_CHAR  ret;

        ret = GrGetNextExposeWin(&evt,req->wid);

        GsWriteType(current_fd,GrNumGetNextExposeWin);
        GsWrite(current_fd, &evt, sizeof(evt));
        GsWrite(current_fd, &ret, sizeof(GR_CHAR));
}

void
GrSetClipRectanglesWrapper(void *r)
{
        nxSetClipRectanglesReq *req = r;
        int        count;
        int        total;

        count = GetReqVarLen(req) / sizeof(GR_RECT);
        total = req->n;
        if (total==count)
                GrSetClipRectangles(req->gcid, req->origin_x, req->origin_y, count, (GR_RECT*)GetReqData(req));
        else
        {
                static int sub_total = 0;

                if (sub_total==0)
                {
                        /* First set */
                        GrSetClipRectangles(req->gcid, req->origin_x, req->origin_y, count, (GR_RECT*)GetReqData(req));
                }
                else
                {
                        /* Next ones */
                        GrAddClipRectangles(req->gcid, req->origin_x, req->origin_y, count, (GR_RECT*)GetReqData(req));
                }
                sub_total += count;
                if (sub_total==total)
                {
                        sub_total = 0;
                }
        }
}

void
GrClearAreaWrapper_obselete(void *r)
{
        nxClearArea_obseleteReq *req = r;

        GrClearArea(req->windowid, req->x,req->y,req->width,req->height,req->exposeflag);
}

void
GrGetPointerWrapper(void *r)
{
        nxGetPointerReq *req = r;
        GR_COORD        coordx;
        GR_COORD        coordy;
        GR_WINDOW_ID    return_wid;

        GrGetPointer(req->windowid, &return_wid, &coordx, &coordy);
        GsWriteType(current_fd,GrNumGetPointer);
        GsWrite(current_fd, &return_wid, sizeof(return_wid));
        GsWrite(current_fd, &coordx, sizeof(coordx));
        GsWrite(current_fd, &coordy, sizeof(coordy));
}

void
GrMoveResizeWindowWrapper(void *r)
{
        nxMoveResizeWindowReq *req = r;
        GrMoveResizeWindow(req->windowid,  req->x,req->y,req->width,req->height);
}

void
GrSetBackgroundPixmapWrapper_aux(void *r)
{
        nxSetBackgroundPixmap_auxReq *req = r;

        GrSetBackgroundPixmap(req->windowid, req->pixmap, req->parent_relative);
}

static void
GrSegmentsWrapper(void *r)
{
        nxSegmentsReq *req = r;
        int count;
        count= GetReqVarLen(req)/sizeof(GR_SEGMENT);
        GrSegments(req->drawid, req->gcid, count, (GR_SEGMENT*)GetReqData(req));}

static void
GrSetEncodingWrapper(void *r)
{
        nxSetEncodingReq *req = r;
        GrSetEncoding(req->encoding);
}

static void
GrGetEncodingWrapper(void *r)
{
        nxGetEncodingReq *req = r;
        GrGetEncoding(&req->encoding,&req->width);

        GsWriteType(current_fd, GrNumGetEncoding);
        GsWrite(current_fd, &req->encoding, sizeof(int));
        GsWrite(current_fd, &req->width, sizeof(int));
}

static void
GrLinesWrapper(void *r)
{
        nxPointsReq *req = r;
        int count;
        count= GetReqVarLen(req)/sizeof(GR_POINT);
        GrLines(req->drawid, req->gcid, count, (GR_POINT*)GetReqData(req));
}

/* Add by Jason for calibration */
static void GrCalibrationWrapper(void *r)
{
        nxCalibrationReq *req;
        req = r;
        GrCalibration(req->perform_calibration, req->a, req->b, req->c, req->d, req->e, req->f, req->s);
}
/* End */

static void
GrAreaSrcWrapper(void *r)
{
        nxAreaSrcReq *req = r;

        GrAreaAlpha(req->drawid, req->gcid, req->x, req->y, req->width, req->height,
                GetReqData(req), req->pixtype,req->alpha_value);
}

/* Add by Jason in order to invert color of specific area */
static void GrInvertColorAreaWrapper(void *r)
{
        nxInvertColorAreaReq *req;
        req = r;

        GrInvertColorArea(req->drawid, req->gcid, req->type, req->x, req->y, req->width, req->height);
}

/* Add by Jason to link the keyboard bitmap to the server */
static void GrLinkBitmapToServerWrapper(void *r)
{
        nxLinkBitmapToServerReq *req;
        req = r;

#ifdef LINK_BITMAP_TO_SERVER
        GrLinkBitmapToServer(req->drawid, req->gcid, req->x, req->y, req->name);
#endif
}
/* End */

static void
GrClearChildAreaWrapper(void *r)
{
        nxClearChildAreaReq *req = r;
        GrClearChildArea(req->wid, req->x, req->y, req->width, req->height);
}

static void
GrGetSelectionOwnerWrapper_aux(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        GR_WINDOW_ID    wid;
        nxGetSelectionOwner_auxReq *req = r;

        wid = GrGetSelectionOwner_aux(req->atom);
        GsWriteType(current_fd,GrNumGetSelectionOwner);
        GsWrite(current_fd, &wid, sizeof(wid));
#endif
}

static void
GrSetSelectionOwnerWrapper_aux(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        nxSetSelectionOwner_auxReq *req = r;
        GrSetSelectionOwner_aux(req->owner, req->atom, req->time);
#endif
}
static void
GrConvertSelectionWrapper(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        nxConvertSelectionReq *req = r;
        GrConvertSelection(req->atom, req->target, req->prop,
                req->requestor,req->time);
#endif
}

static void
GrGetAtomNameWrapper(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        nxGetAtomNameReq *req=r;
        GR_CHAR*        string;
        int     len=0;

        GrGetAtomName(req->atom, &string);
        if(string)
                len = strlen(string)+1;
        GsWriteType(current_fd,GrNumGetAtomName);
        GsWrite(current_fd, &len, sizeof(len));
        if(len)
                GsWrite(current_fd, string, len);
#endif
}

static void
GrInternAtomWrapper(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        nxInternAtomReq *req = r;
        GR_ATOM_ID atom_found;
        atom_found = GrInternAtom((GR_CHAR*)GetReqData(req), req->only_if_exists);
        GsWriteType(current_fd, GrNumInternAtom);
        GsWrite(current_fd, &atom_found, sizeof(GR_ATOM_ID));
#endif
}

static void
GrGetWindowPropWrapper(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        nxGetWindowPropReq *req = r;
        GR_ATOM_ID type;
        int format, n=0, count=0;
        unsigned long nitems;
        GR_CHAR *prop, *tmp;

        GrGetWindowProp(req->wid, req->prop_id, &type, &format, &nitems, &prop);        tmp = prop;
        GsWriteType(current_fd,GrNumGetWindowProp);
        GsWrite(current_fd, &type, sizeof(type));
        GsWrite(current_fd, &format, sizeof(format));
        GsWrite(current_fd, &nitems, sizeof(nitems));
        if(nitems)
        {
                count =nitems +1;
                GsWrite(current_fd, &count, sizeof(count));
                GsWrite(current_fd, prop, count);
        }

#endif
}

static void
GrChangePropWrapper(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        nxChangePropReq *req = r;

        GrChangeProp(req->wid, req->prop_id, req->type, req->format,
                        (GR_CHAR*)GetReqData(req), req->nitems);
#endif
}

static void
GrDeletePropWrapper(void *r)
{
#ifdef CLIPBOARD_SUPPORT
        nxDeletePropReq *req = r;
        GrDeleteProp(req->wid, req->prop_id);
#endif
}

static void
GrExitDrawingModeWrapper()
{
        GrExitDrawingMode();
}

static void
GrGetRegionWrapper(void *r)
{
        nxGetRegionReq          *req = r;
        GR_BOOL                 ret_value;
        MWCLIPREGION            ret_rgn;
        int                     i;

        ret_value = GrGetRegion(req->regionid, &ret_rgn);

        GsWriteType(current_fd, GrNumGetRegion);
        GsWrite(current_fd, &ret_rgn, sizeof(ret_rgn));
        GsWrite(current_fd, &ret_value, sizeof(ret_value));
        for (i=0;i<ret_rgn.numRects;i++)
        {
                GsWrite(current_fd,&(ret_rgn.rects[i]),sizeof(MWRECT));
        }
}

static void
GrGetFontListWrapper_aux(void *r)
{
        nxGetFontList_auxReq        *req = r;
        int                     ret_value;
        int                     i;
        char                    **list = NULL;
        char                    *name = GetReqData(req);

        name[GetReqVarLen(req)] = '\0';
        ret_value = GrGetFontList_aux(name, &list);

        GsWriteType(current_fd, GrNumGetFontList);
        GsWrite(current_fd, &ret_value, sizeof(ret_value));
        for (i=0;i<ret_value;i++)
        {
                int len = strlen(list[i]);
                GsWrite(current_fd,&len,sizeof(int));
                GsWrite(current_fd,list[i],len);
                free(list[i]);
        }
        free(list);
}

void
GrSetGCRegionXWrapper(void *r)
{
        nxSetGCRegionXReq *req = r;
        int        count;
        int        total;
        MWRECT     extents;

        count = GetReqVarLen(req) / sizeof(MWRECT);
        total = req->numRects;
        extents.left = req->left;
        extents.top = req->top;
        extents.right = req->right;
        extents.bottom = req->bottom;
        if (total==count)
                GrSetGCRegionX(req->gcid, req->size, req->numRects, count, &extents, (MWRECT*)GetReqData(req));
        else
        {
                static int sub_total = 0;

                if (sub_total==0)
                {
                        /* First set */
                        GrSetGCRegionX(req->gcid, req->size, req->numRects, count, &extents, (MWRECT*)GetReqData(req));
                }
                else
                {
                        /* Next ones */
                        GrAddGCRegionX(req->gcid, req->size, req->numRects, count, (MWRECT*)GetReqData(req));
                }
                sub_total += count;
                if (sub_total==total)
                {
                        sub_total = 0;
                }

        }
}

static void
GrSetGCMaskWrapper(void *r)
{
        nxSetGCMaskReq *req = r;

        GrSetGCMask(req->gcid, req->x, req->y, req->width, req->wid);
}

static void
GrTilePixmapWrapper(void *r)
{
        nxTilePixmapReq *req = r;

        GrTilePixmap(req->wid, req->pid, req->gcid,
                req->dst_x, req->dst_y,
                req->src_x, req->src_y,
                req->width, req->height);
}

#if (0)
static void
GrClearWindowWrapper(void *r)
{
        nxClearWindowReq *req = r;

        GrClearWindow(req->windowid, req->exposeflag);
}
#endif // 0

static void
GrSetCursorWrapper_aux(void *r)
{
#ifdef CURSOR
        nxSetCursor_auxReq *req = r;
        int             varlen;
        char *          bitmap;

        varlen = GetReqVarLen(req);
        bitmap = GetReqData(req);

        GrSetCursor_aux(req->windowid, req->width, req->height,
                req->hotx, req->hoty, req->fgcolor, req->bgcolor,req->useparent,                (GR_BITMAP *)bitmap, (GR_BITMAP *)(bitmap+varlen/2));
#endif //CURSOR
}

#endif // srvnet_gtkC_c
