#include "serv.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef CLIPBOARD_SUPPORT
static int next_atomid = 300;

/*
 * GsNewSelection()
 * Allocate a new selection struture memory space and add it
 * the list to be search later.
 * This struture not only contain the selection (PRIMARY, CLIPBOARD,
 * SECONDARY),it's can as well contain properrty atom info as well.
 */
GR_SELECTION*
GsNewSelection()
{
	GR_SELECTION* selectionp=NULL;

	selectionp = (GR_SELECTION*) malloc(sizeof(GR_SELECTION));
	if(selectionp == NULL)
	{
		GsError(GR_ERROR_MALLOC_FAILED, 0);
		return NULL;
	}
	/* Add the the new list */	
	selectionp->atom =  next_atomid++;
	selectionp->next = listselection;
	listselection = selectionp;
	return selectionp;
}

/*
 * GsAtomIntern()
 * atom : atom id to be search.
 * Find the selection struture from the listselection which match
 * the atom id.
 */
GR_SELECTION*
GsAtomIntern(GR_ATOM_ID atom)
{
	GR_SELECTION *selection;

	/*FIXME: Should hvae cahce list for selection */
	for(selection=listselection; selection; selection=selection->next)
	{
		if(selection->atom == atom)
		{
			return selection;
		}
	}
	return NULL;
}

/*
 * GsFindAtom()
 * atom_name: atom_name to be seach
 * Find the selection structure from the listselection which match the
 * atom_name.
 * Each atom name is unique and case sensitive.
 */
GR_SELECTION*
GsFindAtom(GR_CHAR *atom_name)
{
        GR_SELECTION *selection;

        /*cahce list for selection */
	if( cacheselection && !strcmp(cacheselection->string, atom_name))
		return cacheselection;

        for(selection=listselection; selection; selection=selection->next)
        {
		/*is case sensiive */
                if(!strcmp(selection->string, atom_name))
                { 
			cacheselection = selection;
                        return selection;
                }
        }
        return NULL;    
}

/*
 * GsAddPropList()
 * text_prop : the data of the property to be add
 * prop_id : the property atom
 * owner : owner of the property
 * Add the data and property and the owner info the the property list.
 */
void
GsAddPropList(GR_TEXT_PROP text_prop, GR_ATOM_ID prop_id, GR_WINDOW_ID owner)
{
	GR_PROP_LIST *proplist;

	proplist = (GR_PROP_LIST*)malloc(sizeof(GR_PROP_LIST));

	if(proplist)
	{
		proplist->textprop = text_prop;
		proplist->prop_id = prop_id;
		proplist->owner = owner;
		proplist->textprop.value = (GR_CHAR*)malloc(text_prop.nitems);
		memcpy(proplist->textprop.value, text_prop.value, text_prop.nitems);
		proplist->next = listpropdata;
		listpropdata = proplist;
	}
}

/*
 * GsFindProp()
 * prop_type : the encoding format atom, could STRING, COMPOUND_STRING, TEXT.
 * prop_id : the property atom to be search GDK_SELECTION
 * wid : the owner of the property
 * This function will find the property structure which match the 
 * window , property atom and property_type. If 0 is specified,
 * the searching criteria is ignored.
 */
GR_PROP_LIST*
GsFindProp(GR_ATOM_ID prop_id, GR_WINDOW_ID wid)
{
	GR_PROP_LIST *proplistp;

	/*
   	 * Is the cache data is the one we want 
  	 */

	 if( cacheprop && ( cacheprop->prop_id == prop_id || !prop_id) &&
                ( cacheprop->owner == wid || !wid) )
		return cacheprop;

	for(proplistp =  listpropdata; proplistp; proplistp = proplistp->next)
	{
		if( ( proplistp->prop_id == prop_id || !prop_id) && 
		( proplistp->owner == wid || !wid) )
		{
			cacheprop = proplistp;
			return proplistp;
		}
	}
	return NULL;
}

/*
 * GsDeleteProperty()
 * wid : the property owner
 * prop_id : the property atom to be deleted
 * This function will remove the property of the given owner from thw
 * property list.
 * On Success, 1 is returned otherwise 0.
 */
int
GsDeleteProperty(GR_WINDOW_ID wid, GR_ATOM_ID prop_id)
{
	GR_PROP_LIST *prop;
        GR_PROP_LIST *prevprop;

        prop = GsFindProp(prop_id, wid);
        if(!prop)
                return GR_FALSE;

        if(cacheprop == prop)
                cacheprop = NULL;

        if(listpropdata == prop)
        {
                listpropdata = prop->next;
                if(prop->textprop.value) free(prop->textprop.value);
                free(prop);
		return GR_TRUE;
        }

        prevprop = listpropdata;
        while (prevprop->next != prop)
                prevprop = prevprop->next;

        prop->next = prop->next;
        //if(prop->textprop.value) free(prop->textprop.value);
        free(prop);

	return GR_TRUE;
}
#endif
