#!/bin/sh

GTK_DIR=NanoGTK-1.0
GTK_VN=1.2.7
GLIB_VN=1.2.7
MWIN_VN=089p8


if [ x$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      export NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/$USER/$GTK_DIR ]; then
      export NANOGTK_HOME=/home/$USER/$GTK_DIR
   else
      echo
      echo "NANOGTK_HOME not defined"
      exit 1
   fi
fi


show_usage ()
{
   echo
   echo "usage: $0 pub [debug]"
   echo
   exit 0
}


build_package ()
{
   cd $1

   ./rebuild.sh $TARGET $debug

   if [ $? != 0 ]; then
      exit 1
   fi

   cd ..
}


#
# compile libraries
#
compile_lib ()
{
   all="zlib microwin$MWIN_VN glib-$GLIB_VN gtk+-$GTK_VN"

   for d in $all
   do
      build_package $d
   done
}


if [ x$1 = x ]; then
   show_usage
fi

debug="$2"

case $1 in
   pub|x86)
      TARGET=$1

      echo
      echo -n "Are you sure to rebuild all (y/n)? "
      read answer

      if [ "$answer" != y ]; then
         echo "aborted"
         exit 0
      fi
      ;;
   *)
      show_usage
      ;;
esac


compile_lib
cd Application
./rebuild.sh $1
cd ..
date > .BUILDINFO


exit 0

