#!/bin/sh

GTK_DIR=NanoGTK-1.0
GTK_VN=1.2.7
GLIB_VN=1.2.7
MWIN_VN=089p8


if [ x$NANOGTK_HOME = x ]; then
   if [ -d /opt/$GTK_DIR ]; then
      export NANOGTK_HOME=/opt/$GTK_DIR
   elif [ -d /home/$USER/$GTK_DIR ]; then
      export NANOGTK_HOME=/home/$USER/$GTK_DIR
   else
      echo
      echo "NANOGTK_HOME not defined"
      exit 1
   fi
fi


compile ()
{
   make $1

   rcode=$?

   if [ $rcode != 0 ]; then
      exit $rcode
   fi
}


moveit ()
{
   if [ ! -d include ]; then
      mkdir include
   fi

   cp -p zlib.h include
}


case $1 in
   pub|x86)
      make clean
      compile $1
      moveit
      ;;
   *) make
      ;;
esac

exit 0

